# CodeAbility Sharing Platform V0.0

This is an initial version V0.0 of the CodeAbility Sharing platform. 
The goal of this initial version is to 

- allow an initial exchange of resources (e.g., lab exercises, lecture slides, collections of links, or Artemis exercises),
- give us a first concrete impression on available material to be shared.

This prototype uses the community edition of GitLab, which, among others, provides a web-based Git repository manager. 
Therefore, the well-known and established processes of Git can be used for sharing resources. In the following, the registration, usage, and plans are discussed.

Our plans are to extend the usability and functionality of the sharing platform step by step to make it more suitable to the project's needs.

As a very first beginning the platform 

- is restricted to the closed user group of project partners,
- is expected to contain only material under the [CC-BY-SA V4.0](https://creativecommons.org/licenses/by-sa/4.0/) license. (If this condition is a severe problem for you, please let us know.)

We will lift these restrictions step-by-step and add further functionality when we progress with the platform.

## 1. Registration

The sharing platform is available on https://sharing-codeability.uibk.ac.at/. We would kindly ask you to use the self-registration function and inform us via email (sharing-codeability@uibk.ac.at). As soon as we verified your access permission, you can access all resources, which your colleges have been sharing. 

## 2. Usage

After your successful registration, a lot of features are available for you. In this evaluation phase, we focus on the three main use-cases - publish, view, and discuss resources. Those are described in the following.

### 2.1 Publish Resources

For publishing resources, you can create new repositories in the group `sharing`/`<your university>`. Please, use an informative repository name when creating 
a new repository (currently, you cannot search for specific terms across all repositories). 
A repository can contain various resources like a course, an exercise, or a list of links. 
However, please ensure that you only join resources in a single repository that are somehow related and do not use a single repository as a large data container. 

Moreover, you should include a `Readme.md`-File in each repository that comprises a description of the repository's content and possibly the requirements (e.g., to solve the exercises). The latest version should always be available in the master branch. For further iterations of the course, version tags can be used.
We recommend additional files

   - `LICENSE` (may contain the legal license terms)
   - `metadata.yaml` (as a first example see [some artemis exercise](https://sharing-codeability.uibk.ac.at/sharing/codeability-sharing-platform/-/wikis/technical/MetaData%20Documentation)). The format ist described [here](https://sharing-codeability.uibk.ac.at/sharing/codeability-sharing-platform/-/wikis/technical/MetaData%20Documentation)

To improve the search experience of relevant repositories, you can provide topics and a project description (see `Settings`/`General`). As a reference, you can take a look at a [demo repository](https://sharing-codeability.uibk.ac.at/sharing/university-innsbruck/java/general/junit-quality-tests-exercise).
Note that in this version, all resources are published under the license CC BY-SA.

### 2.2 View Resources

After an interesting project was found in the shared group `sharing`, the content can be viewed in the web browser, or the repository can be downloaded by Git means into your local repository.

### 2.3 Discuss Resources

For discussing the material or asking questions about the resources of a repository, issues can be used.


## 3. Plans

For the immediate next steps, we think that the following extensions would be beneficial.

* Full-text search across all repositories
* Support for EduID
* Collection and search for metadata

These features will be made available as soon as they are available.